Index: /trunk/IPs/systemC/processor/Morpheo/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Makefile	(revision 88)
@@ -1,98 +1,58 @@
-include $(MORPHEO_TOPLEVEL)/Makefile.tools
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#----------------------------------------------------------------------
+#----------------------------------------------------------------------
+#-----[ Variables ]----------------------------------------------------
+#----------------------------------------------------------------------
+#----------------------------------------------------------------------
 
 #-----[ Directory ]----------------------------------------------------
-DIR_LIB			= Library
-DIR_DOC			= Documentation/Source
+DIR_DOC			= ./Documentation/Source
+DIR_LOCALE		= ./locale
 
-#-----[ Options ]------------------------------------------------------
+#----------------------------------------------------------------------
+#----------------------------------------------------------------------
+#-----[ Rules ]--------------------------------------------------------
+#----------------------------------------------------------------------
+#----------------------------------------------------------------------
+.PHONY			: all help lib translate clean clean_all
 
-PREFIXE_PATH		= "."
-SUFFIXE_PATH            = ".txt"
+all			: doc translate lib
 
-#-----[ Rules ]--------------------------------------------------------
-.PHONY			: all help
-
-all			: help
-
-#~~~~~[ doc ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 doc			:
 			@\
-			$(ECHO) "";\
-			$(ECHO) "=====[ doc ]=====================================";\
-			$(ECHO) "";\
-			$(MAKE) -C $(DIR_DOC) view;
+			$(MAKE) -C $(DIR_DOC) doc;
 
-#~~~~~[ path ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-path			:
+lib 			: Morpheo_library
+
+translate		:
 			@\
-			$(ECHO) "";\
-			$(ECHO) "=====[ path ]====================================";\
-			$(ECHO) "";\
-			$(ECHO) -n "+ ";\
-			$(BASENAME) $(PWD);\
-			$(ECHO) "| <Top Level>";\
-			$(ECHO) "|";\
-			$(MAKE) path_rec TAB="|    " DIR_PATH=.;
+			for i in $(DIR_LOCALE)/*/*/*.po; do 		\
+				dir=$$($(DIRNAME) $$i); 		\
+				file=$$($(BASENAME) $$i .po);		\
+				$(ECHO) "Translate          : $$i";	\
+				$(MSGFMT) $$i -o $$dir/$$file.mo;	\
+			done
 
-path_rec		:
-			@\
-			for files in `$(LS) $(DIR_PATH)`; do								\
-			    	if $(TEST) -d $(DIR_PATH)/$$files; 							\
-				then 											\
-					$(ECHO) "$(TAB)+ $$files";							\
-															\
-					if test -f $(DIR_PATH)/$(PREFIXE_PATH)`$(BASENAME) $$files`$(SUFFIXE_PATH);	\
-					then										\
-						$(ECHO) "$(TAB)| <\c";							\
-						$(CAT) $(DIR_PATH)/$(PREFIXE_PATH)`$(BASENAME) $$files`$(SUFFIXE_PATH);	\
-						$(ECHO) ">";								\
-					else										\
-						$(ECHO) "$(TAB)| <No description>";					\
-					fi;										\
-					$(ECHO) "$(TAB)|"; 								\
-															\
-					$(MAKE) path_rec TAB="$(TAB)|    " DIR_PATH=$(DIR_PATH)/$$files;		\
-				fi;											\
-			done;
-
-#~~~~~[ Lib ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-lib 			:
-			@\
-			$(ECHO) "";\
-			$(ECHO) "=====[ lib ]=====================================";\
-			$(ECHO) "";\
-			$(ECHO) " Function unimplemented";\
-			$(ECHO) "";
-
-#			@$(ECHO) " The library is generate into the directory : $(PWD)/$(DIR_LIB)"
-
-#~~~~~[ Maintenance ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#~~~~~[ Clean ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 clean 			:
 			@\
-			$(ECHO) "";\
-			$(ECHO) "=====[ clean ]===================================";\
-			$(ECHO) "";\
-			$(ECHO) "Delete     temporary files              "$(PWD);\
-			$(RM) *~;
-#			@$(MAKE) clean_rec DIR_CLEAN=.
+			$(RM) *~;\
+			$(MAKE) -C $(DIR_DOC) clean;
 
-#Clean recursive
-#clean_rec		:
-#			@$(ECHO) "Delete     temporary files in directory $(DIR_CLEAN)"
-#			@$(RM) -f $(DIR_CLEAN)/*~
-#			@										\
-#			if $(TEST) -f $(DIR_CLEAN)/Makefile -a "$(DIR_CLEAN)" != ".";			\
-#			then 										\
-#		       		($(CD) $(DIR_CLEAN); $(MAKE) clean;)                    		\
-#			else										\
-#				for files in `$(LS) $(DIR_CLEAN)`; do					\
-#				    	if $(TEST) -d $(DIR_CLEAN)/$$files; 				\
-#					then 								\
-#						$(MAKE) clean_rec DIR_CLEAN=$(DIR_CLEAN)/$$files;	\
-#					fi;								\
-#				done;									\
-#			fi;
+
+clean_all		:
+			@\
+			$(RM) *~ $(DIR_LOCALE)/*/*/*.mo;\
+			$(MAKE) -C $(DIR_DOC) clean_all;\
+			$(MAKE)  Morpheo_library_clean
+
 
 #~~~~~[ Help ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -107,8 +67,10 @@
 			$(ECHO) " * all              cf rule \"help\"";\
 			$(ECHO) " * clean            Delete temporary files";\
+			$(ECHO) " * clean_all        Delete all generated files";\
 			$(ECHO) " * doc              View documentation files";\
+			$(ECHO) " * help             Print this message";\
 			$(ECHO) " * lib              Generate the library to include";\
-			$(ECHO) " * help             Print this message";\
-			$(ECHO) " * path             Print a little description of each directory";\
+			$(ECHO) " * translate        Generate the traduction";\
 			$(ECHO) "";
 
+include Makefile.deps
Index: /trunk/IPs/systemC/processor/Morpheo/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Makefile.deps	(revision 88)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+
+#-----[ Test ]---------------------------------------------
+
+# Test Environment variables
+ifeq ($(origin MORPHEO_TOPLEVEL), undefined)
+        $(error "variable MORPHEO_TOPLEVEL is undefined");
+else
+        include $(MORPHEO_TOPLEVEL)/Makefile.tools
+endif
+
+#-----[ Dependency ]---------------------------------------
+
+DIR_MORPHEO    = $(MORPHEO_TOPLEVEL)/IPs/systemC/processor/Morpheo/
+include $(DIR_MORPHEO)/TopLevel/Makefile.deps
+
+#-----[ Variables ]----------------------------------------
+
+MORPHEO_DIR     = $(DIR_MORPHEO)
+MORPHEO_INCDIR  = -I$(MORPHEO_DIR) -I$(MORPHEO_DIR)/TopLevel/include
+MORPHEO_LIBDIR  = $(Morpheo_DIR_LIBRARY)
+MORPHEO_LIBNAME = $(Morpheo_LIBRARY) -lm
Index: /trunk/IPs/systemC/processor/Morpheo/Script/SelfTest.sh
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Script/SelfTest.sh	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Script/SelfTest.sh	(revision 88)
@@ -10,84 +10,102 @@
 declare    test_ok="Test OK";
 declare    tmp="${MORPHEO_HOME}/tmp/SelfTest";
-declare    path="${MORPHEO_TOPLEVEL}/IPs/systemC/processor/Morpheo/Behavioural";
+declare    path="${MORPHEO_TOPLEVEL}/IPs/systemC/processor/Morpheo/";
 
 declare -a directory=(
-    ""
-    "Custom"
-
-    "Generic/Counter"
-    "Generic/Queue_Control"                                 
-    "Generic/Queue"                                 
-    "Generic/RegisterFile/RegisterFile_Monolithic"  
-    "Generic/RegisterFile/RegisterFile_Multi_Banked"
-    "Generic/RegisterFile"                          
-    "Generic/Select/Select_Priority_Fixed"           
-    "Generic/Select"                                
-    "Generic/Shifter"                               
-    "Generic/Sort"                                  
-    "Generic/Victim/Victim_Pseudo_LRU"              
-    "Generic/Victim"                                
-
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit"
-    "Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit"
-    "Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit"
-    "Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit"
-    "Core/Multi_Execute_loop/Execute_loop/Network"
-    "Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue"
-    "Core/Multi_Execute_loop/Execute_loop/Register_unit"
-#   "Core/Multi_Execute_loop/Execute_loop"
-#   "Core/Multi_Execute_loop"
-
-    "Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Load_Store_pointer_unit"
-    "Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Dependency_checking_unit"
-    "Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit"
-    "Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit"
-    "Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_translation_unit_Glue"
-    "Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit"
-    "Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit"
-    "Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Rename_queue"
-    "Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Rename_select"
-    "Core/Multi_OOO_Engine/OOO_Engine/Rename_unit"
-    "Core/Multi_OOO_Engine/OOO_Engine"
-    "Core/Multi_OOO_Engine"
+    "Common"
+
+    "Behavioural"
+    "Behavioural/Configuration"
+    "Behavioural/Custom"
+
+    "Behavioural/Generic/Counter"
+    "Behavioural/Generic/Priority"
+    "Behavioural/Generic/Queue_Control"                                 
+    "Behavioural/Generic/Queue"                                 
+    "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic"  
+    "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked"
+    "Behavioural/Generic/RegisterFile"                          
+    "Behavioural/Generic/Select/Select_Priority_Fixed"           
+    "Behavioural/Generic/Select"                                
+    "Behavioural/Generic/Shifter"                               
+    "Behavioural/Generic/Sort"                                  
+    "Behavioural/Generic/Victim/Victim_Pseudo_LRU"              
+    "Behavioural/Generic/Victim"                                
+
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit"
+    "Behavioural/Core/Multi_Execute_loop/Execute_loop"
+    "Behavioural/Core/Multi_Execute_loop"
+
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Load_Store_pointer_unit"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Dependency_checking_unit"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_translation_unit_Glue"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Rename_unit_Glue"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Rename_select"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit"
+    "Behavioural/Core/Multi_OOO_Engine/OOO_Engine"
+    "Behavioural/Core/Multi_OOO_Engine"
     
-    "Core/Multi_Front_end/Front_end/Context_State"
-    "Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction"
-    "Core/Multi_Front_end/Front_end/Decod_unit/Decod"
-    "Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue"
-    "Core/Multi_Front_end/Front_end/Decod_unit"
-    "Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management"
-    "Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue"
-    "Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue"
-    "Core/Multi_Front_end/Front_end/Ifetch_unit"
-    "Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue"
-    "Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register"
-    "Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer"
-    "Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Direction_Glue"
-    "Core/Multi_Front_end/Front_end/Prediction_unit/Direction"
-#   "Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Meta_Predictor_Glue"
-#   "Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Two_Level_Branch_Predictor_Glue"
-#   "Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Branch_History_Table"
-#   "Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Pattern_History_Table"
-#   "Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor"
-#   "Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor"
-    "Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue"
-    "Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack"
-    "Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table"
-    "Core/Multi_Front_end/Front_end/Prediction_unit"
-    "Core/Multi_Front_end/Front_end"
-    "Core/Multi_Front_end"
-
+    "Behavioural/Core/Multi_Front_end/Front_end/Context_State"
+    "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction"
+    "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod"
+    "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue"
+    "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit"
+    "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue"
+    "Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management"
+    "Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue"
+    "Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue"
+    "Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit"
+    "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue"
+    "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register"
+    "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer"
+    "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Direction_Glue"
+    "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction"
+#   "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Meta_Predictor_Glue"
+#   "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Two_Level_Branch_Predictor_Glue"
+#   "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Branch_History_Table"
+#   "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Pattern_History_Table"
+#   "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor"
+#   "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor"
+    "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue"
+    "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack"
+    "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table"
+    "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit"
+    "Behavioural/Core/Multi_Front_end/Front_end"
+    "Behavioural/Core/Multi_Front_end"
+
+    "Behavioural/Core/Icache_Access"
+    "Behavioural/Core/Dcache_Access"
+
+    "Behavioural/Core/Core_Glue"
+    "Behavioural/Core"
+
+    "TopLevel"
     );
                                            
@@ -126,5 +144,5 @@
 
     if test ! -d ${tmp}; then
-	mkdir ${tmp};
+	mkdir -p ${tmp};
     fi;
 
@@ -212,15 +230,17 @@
 
 		cd ${path}/${i};
-		make clean;
-		dir="SelfTest";
-
-		if test -d ${dir}; then
-		    cd ${dir};
+
+                if test -f "Makefile"; then
 		    make clean;
-		else
-		    echo "${component} have not SelfTest directory.";
-		fi;
-		cd ${pwd};
-
+		    dir="SelfTest";
+                    
+		    if test -d ${dir}; then
+		        cd ${dir};
+		        make clean;
+		    else
+		        echo "${component} have not SelfTest directory.";
+		    fi;
+		    cd ${pwd};
+                fi;
 	    done;
 	    ;;
Index: /trunk/IPs/systemC/processor/Morpheo/Script/version.sh
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Script/version.sh	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Script/version.sh	(revision 88)
@@ -7,4 +7,5 @@
 file_sed_src="${MORPHEO_TOPLEVEL}/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h.sed";
 file_sed_dest="${MORPHEO_TOPLEVEL}/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h";
+file_sed_script="/tmp/file_sed_script";
 
 #-----[ usage ]---------------------------------------------
@@ -47,7 +48,17 @@
 	    # +1 because is the next revision
 	    revision=$(($(export LC_ALL=C; svnversion  | tr -d [:alpha:] | cut -d : -f 2) + 1));
-    
-	    cat ${file_sed_src} |sed s/"@REVISION"/"${revision}"/ &> ${file_sed_dest};
-    
+            date_day=$(date +%d);
+            date_month=$(date +%m);
+            date_year=$(date +%Y);
+            
+            echo "s/\"@REVISION\"/\"${revision}\"/"     >  ${file_sed_script};
+            echo "s/\"@DATE_DAY\"/\"${date_day}\"/"     >> ${file_sed_script};
+            echo "s/\"@DATE_MONTH\"/\"${date_month}\"/" >> ${file_sed_script};
+            echo "s/\"@DATE_YEAR\"/\"${date_year}\"/"   >> ${file_sed_script};
+
+	    cat ${file_sed_src} |sed -f ${file_sed_script} &> ${file_sed_dest};
+
+            rm ${file_sed_script};
+            
 	    svn commit;
 
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/Makefile	(revision 88)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ./
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ Library ]------------------------------------------
+LIBRARY				= $(DIR_LIB)/libMorpheo.a
+
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_component
+
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/Makefile.defs	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/Makefile.defs	(revision 88)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/Makefile.deps	(revision 88)
@@ -0,0 +1,47 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+Morpheo                         = yes
+
+ifndef Configuration
+include 			$(DIR_MORPHEO)/Behavioural/Configuration/Makefile.deps
+endif
+ifndef Core
+include 			$(DIR_MORPHEO)/Behavioural/Core/Makefile.deps
+endif
+
+#-----[ Directory ]----------------------------------------
+
+Morpheo_DIR			=	$(DIR_MORPHEO)/TopLevel
+
+#-----[ Library ]------------------------------------------
+
+Morpheo_LIBRARY 		= 	-lMorpheo                       \
+					$(Configuration_LIBRARY)	\
+                                        $(Core_LIBRARY)	
+
+Morpheo_DIR_LIBRARY		=	-L$(Morpheo_DIR)/lib            \
+					$(Configuration_DIR_LIBRARY)	\
+					$(Core_DIR_LIBRARY)
+
+#-----[ Rules ]--------------------------------------------
+
+Morpheo_library         	:
+				@\
+				$(MAKE) Configuration_library;		\
+				$(MAKE) Core_library;		        \
+				$(MAKE) --directory=$(Morpheo_DIR) --makefile=Makefile;
+
+Morpheo_library_clean	        :
+				@\
+				$(MAKE) Configuration_library_clean;	\
+				$(MAKE) Core_library_clean;	        \
+				$(MAKE) --directory=$(Morpheo_DIR) --makefile=Makefile clean;
+
+
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/Makefile	(revision 88)
@@ -0,0 +1,34 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+LIBRARY				= $(Morpheo_LIBRARY)
+
+DIR_LIBRARY			= $(Morpheo_DIR_LIBRARY)
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_selftest
+
+library				: Morpheo_library
+
+library_clean			: Morpheo_library_clean
+
+local_clean			:
+				@$(RM) 	data_in/*~ 	\
+					data_out/*
+
+include                         $(DIR_COMPONENT)/Makefile.deps
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.Synthesis
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/configuration/Morpheo-min.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/configuration/Morpheo-min.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/configuration/Morpheo-min.cfg	(revision 88)
@@ -0,0 +1,1 @@
+../../Files/Morpheo.sim ../../Files/Morpheo.gen ../../Files/Instance_min.cfg
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/include/test.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/include/test.h	(revision 88)
@@ -0,0 +1,33 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test "RegisterFile"
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#define NB_ITERATION  16
+#define CYCLE_MAX     (1024*NB_ITERATION)
+
+#include "Common/include/Test.h"
+#include "Common/include/Time.h"
+#include "TopLevel/include/Morpheo.h"
+
+#include <string>
+#include <iostream>
+#include <sys/time.h>
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural::custom;
+
+void test    (string                 name,
+              std::string            filename_simulator, 
+              std::string            filename_generator, 
+              std::string            filename_instance ,
+              custom_information_t (*get_custom_information) (void)
+              );
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/src/main.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/SelfTest/src/main.cpp	(revision 88)
@@ -0,0 +1,74 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/SelfTest/include/test.h"
+
+#define NB_PARAMS 3
+
+void usage (int argc, char * argv[])
+{
+  err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
+  err (_("list_params is :\n"));
+  err (_(" * filename_simulator (string)\n"));
+  err (_(" * filename_generator (string)\n"));
+  err (_(" * filename_instance  (string)\n"));
+
+  exit (1);
+}
+
+#ifndef SYSTEMC
+int main    (int argc, char * argv[])
+#else
+int sc_main (int argc, char * argv[])
+#endif
+{
+  for (int32_t i=0; i<argc; ++i)
+    msg("%s ",argv[i]);
+  msg("\n");
+
+  if (argc != static_cast<int>(2+NB_PARAMS))
+    usage (argc, argv);
+
+  uint32_t x = 1;
+
+  string name               = argv[x++];
+  string filename_simulator = argv[x++];
+  string filename_generator = argv[x++];
+  string filename_instance  = argv[x++];
+
+  int _return = EXIT_SUCCESS;
+  try 
+    {
+      test (name,
+            filename_simulator,
+            filename_generator,
+            filename_instance,
+            NULL
+// &(morpheo::behavioural::custom::example_get_custom_information)
+            );
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  try 
+    {
+      if (_return == EXIT_SUCCESS)
+	TEST_OK("Morpheo : no error");
+      else
+	TEST_KO("Morpheo : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+//       msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  return (_return);
+}
